import { Options } from '../options';
export interface ProgramStatus {
    [index: string]: any;
    init: () => void;
    start: () => void;
    transform: (fileNames: string[], time: string) => void;
    scan: (time: string) => void;
    cleanup: (time: string) => void;
    diagnostics: (diags: string[], total?: number) => void;
    end: (time: string, totalTime: string) => void;
    warn: (warning: string, defer?: boolean) => void;
    stop: () => void;
    term: () => void;
    error: (error?: string | Error) => void;
}
export declare function start(opts: Options, version: string): void;
export declare function transform(entryFiles: string[]): void;
export declare const status: ProgramStatus;
